function [U,V,A,change_points,extra_info,normalize_scalling,objs] = CADENCE(X,param)


num_iters_check =1;
K=param.K;

normalize_scalling = ones(K,1);
number_of_modes=3;
rho_u = param.rho_u;

[M]= size(X);
n1=M(1);
n2=M(2);
t=M(3);

%% Constant prep

rho_u_I= rho_u *eye(K);

%% initlization
rng(0)
U = rand(n1,K);
V = rand(n2,K);

Gamma_2=0;



factors{1}=U;
factors{2}=V;



for i=1:2
   factor_inner_prod(:,:,i)=factors{i}'*factors{i}; 
end

factors{3}= eye(t,K);

fit = 0;


fprintf('CADENCE:\n');

  
Recon_T = ktensor(normalize_scalling, factors);

normX = norm(X); 

objs(1,1) =  sqrt( normX^2 + norm(Recon_T)^2 - 2 * innerprod(X,Recon_T) );

%% Main Loop: Iterate until convergence
    for iter = 1:param.maxiters

        tic;
        

         UTU_VTV = prod(factor_inner_prod(:,:,[1,2]),3);
         X_U_V = mttkrp(X,factors,3);
        
          %% A update 

          
            [H,A,change_points,extra_info] = CADENCE_OMP(X_U_V*inv(UTU_VTV),param.budget,K,param);
        
              

            factors{3}=full(H*A);               
            factor_inner_prod(:,:,3)=factors{3}'*factors{3};     

                

             %% U
                           
           
              U = (mttkrp(X,factors,1)+rho_u*V-Gamma_2)*...
                  inv(prod(factor_inner_prod(:,:,[2,3]),3)+rho_u_I);

                  
               U = U .*(U>0);
               
              
                

              normalize_scalling = max(U);
              normalize_scalling = sum(U,1);
      
               U = bsxfun(@rdivide, U, normalize_scalling);
                 
              
              factors{1} = U;
              factor_inner_prod(:,:,1)=factors{1}'*factors{1};
              
              
           %% V
                 V = (mttkrp(X,factors,2)+rho_u*U+Gamma_2)*...
              inv(prod(factor_inner_prod(:,:,[1 3]),3)+rho_u_I);
                
                V= V.*(V>0);
                
                
               
                normalize_scalling = sum(V,1);
                
                V = bsxfun(@rdivide, V, normalize_scalling);
                 
               

              factors{2} = V;
              factor_inner_prod(:,:,2)=factors{2}'*factors{2};
                 
              
              %% Gamma
              if(n2==n1)
                Gamma_2 = Gamma_2 + rho_u*(U-V);
              end
      
        
        time_one_iter=toc;

      
       
       if(mod(iter,num_iters_check)==0)
           
          
           %if we don't update the recon
     
            Recon_T = ktensor(normalize_scalling', factors);
                    
            recon_error =sqrt( normX^2 + norm(Recon_T)^2 - 2 * innerprod(X,Recon_T) );
            
            fit_old=fit;
            fit = 1 - (recon_error / normX); %fraction explained by model
            
             objs(iter/num_iters_check+1,1)=recon_error ;
   
    
            fit_change =  fit-fit_old;
               
                disp(append("iteration=" ,num2str(iter)," fit=",  num2str(fit), " f-delta=",  num2str(fit_change) ," reonstuction error=",  num2str(recon_error),...
                      " total=", num2str(objs(iter/num_iters_check+1,:))))
                

                if(fit_change<param.fitchangetol)
                    disp(" algo has met fit change tolerance ")
                   break 
                end

               
                 
       end
       
    end 
    
end

