function [X_disagg,dis_agg_window_sizes] = adj_disagger(X_agg, dis_agg_window_sizes,disagg_window_start,disagg_window_size)
%ADJ_DISAGGER Summary of this function goes here
%   Detailed explanation goes here
dim = size(X_agg); 
 
if isempty(dis_agg_window_sizes)
 dis_agg_window_sizes = randi(disagg_window_size ,dim(3),1)+disagg_window_start;
end
 
 X_disagg= zeros(dim(1),dim(2), sum( dis_agg_window_sizes));
 
 
 diagg_t=0;
 for i=1:length( dis_agg_window_sizes)
 
     
    agg_frame = X_agg(:,:,i);
     
    edge_ind =  find(agg_frame);
    
    rand_vec = rand(1,dis_agg_window_sizes(i));
    
    rand_vec = ones(1,dis_agg_window_sizes(i));
    percent_edges =rand_vec./sum(rand_vec);
    
    total_edges=length(edge_ind);
     
    % finds how many edges in each frame accept last
    num_edges_per_frame = floor(total_edges.*percent_edges(1:end-1));
    
    % last frame 
    num_edges_per_frame(dis_agg_window_sizes(i))=total_edges-sum(num_edges_per_frame);
    
    
    
    
    for j=1:length(num_edges_per_frame)
        
        chosen_edges = randsample(edge_ind,num_edges_per_frame(j));
        edge_ind= setdiff(edge_ind,chosen_edges);
        
        
        
        
         disagg_frame =zeros(dim(1),dim(2));
         disagg_frame(chosen_edges)=1;
         
         
          diagg_t= diagg_t+1;
          X_disagg(:,:,diagg_t)=disagg_frame ;
         
    end
    

    
 end
 
end

